package soln;
import helper.Labtest11Helper;

import java.io.IOException;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

public class Labtest11_Sec01_Part1 {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) {

		/**
		 * GOAL: iterate over the elements in a collection and identify
		 * duplicate elements.
		 */

		/**
		 * [2 marks] Step 1: Use the getRandom() method of the Labtest11Helper
		 * class to obtain a list of random length and with randomly chosen
		 * positive Integer values. The API can be found in the doc
		 * sub-directory of this package. The class definition is included with
		 * this project in the helper package, so you will need to include the
		 * statement "import helper.Labtest11Helper;" (it has been added for you
		 * already).
		 */

		List<Integer> theList = Labtest11Helper.getRandom();

		/**
		 * [1 mark] Step 2: Iterate over the elements and print each one. Print
		 * "***" at the end.
		 */

		for (Integer i : theList) {
			System.out.println(i);
		}
		System.out.println("***");

		/**
		 * Have a look at the comprehension question. You can decide whether to
		 * answer it before or after Step 3.
		 */

		/**
		 * [7 marks] Step 3: Identify duplicate elements in the list. If you
		 * encounter a duplicate element, then print out the following message
		 * "DUPLICATE " followed by the duplicate element. You may use any
		 * technique you like, such as any of the three techniques identified in
		 * section 10.3.1 or a technique of your own device. The only conditions
		 * are correctness and adherence to good programming principles. You do
		 * not necessarily need to identify them in the order in which they
		 * occur in the list.
		 */

		// // approach 1; (order is not preserved)
		// Collections.sort(theList);
		// for (int i = 0; i < theList.size() - 1; i++) {
		// boolean isDistinct = !theList.get(i).equals(theList.get(i + 1));
		// if (!isDistinct)
		// System.out.println("DUPLICATE " + theList.get(i + 1));
		// }
		//
		// // approach 2
		// System.out.println("***");
		// Set<Integer> blah = new HashSet<Integer>();
		// for (int i = 0; i < theList.size() - 1; i++) {
		// boolean isDistinct = blah.add(theList.get(i));
		// if (!isDistinct)
		// System.out.println("DUPLICATE " + theList.get(i));
		// }
		// approach 3
		// note that if we want to find all dups, need to remove boolean from
		// outer for loop
		System.out.println("***");
		Iterator<Integer> outer = theList.iterator();
		boolean shouldContinue = true;
		for (; outer.hasNext();) {
			Integer x = outer.next();
			Iterator<Integer> inner = theList.iterator();
			shouldContinue = true;
			for (; inner.hasNext() && shouldContinue;) {
				Integer y = inner.next();
				shouldContinue = !x.equals(y) || (x == y);
				System.out.println("***" + x + "\t" + y);
				if (!shouldContinue)
					System.out.println("DUPLICATE " + y);
			}
		}

	}
}
